/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHATINPUT_H
#define CHATINPUT_H

#include "RenderObject.h"
#include <string>
#include <vector>

class GameState;

class ChatInput
{
public:
	ChatInput();
	void setGameState(GameState* gameState);
	bool onEvent(const SDL_Event& event);
	
	bool isReady() const;
	std::string fetch();
	Color fetchCar() const;
	void addPlayer(const std::string& name, int car = -1);
	void removePlayer(int car);
	bool empty() const;
	void clear();
	void addDefaultPlayers();
private:
	void updateRenderObject();

	std::string text;
	bool ready;
	RenderObject renderObject;
	GameState* gameState;
	std::size_t iPlayer;
	struct Player
	{
		std::string name;
		int car;
	};
	std::vector<Player> players;
	int textWidth;
};

#endif

